#
Summary: This will configure the ntpd config files for Fermilab. 
Name: zz_ntp_configure
Version: 4.2.0
Release: 2
Copyright: GPL
Group: Fermi
URL: http://www.fnal.gov/cd/UNIX/linux/
Vendor: Fermilab
Packager: Troy Dawson
requires: ntp,perl
obsoletes: zz_xntp3_change
BuildArch: noarch

%description

This package configures the ntp time daemon correctly for use at Fermilab.  It
sets the initial time from the nameservers (131.225.8.200 and 131.225.17.200) 
and configures ntpd to listen to time broadcasts from the local router of the
subdomain that the machine is on.

The /etc/ntp.conf  will be saved with a suffix of .rpmsave.

%files
%triggerin -- ntp

#
# This modifies /etc/ntp.conf
#
if [ `grep "restrict 131.225.0.0 mask 255.255.0.0 nomodify" /etc/ntp.conf | wc -l` -eq 0 ]; then
  #
  # copy the original off first
  #
	if [ -f /etc/ntp.conf.rpmsave ]; then
        mv /etc/ntp.conf.rpmsave /etc/ntp.conf.rpmsave.o
	fi
	cp /etc/ntp.conf /etc/ntp.conf.rpmsave.$$

  #
  #now actually do the modifications
  #
	perl -pe 's/(^enable bclient)//;' -i /etc/ntp.conf 
	perl -pe 's/authenticate yes/authenticate no/;' -i /etc/ntp.conf
	perl -pe 's/broadcastclient/#broadcastclient/;' -i /etc/ntp.conf
	perl -pe 's/server/#server/;' -i /etc/ntp.conf
	perl -pe 's/fudge/#fudge/;' -i /etc/ntp.conf
	perl -pe 's/multicastclient/#multicastclient/;' -i /etc/ntp.conf

	echo "enable bclient" >> /etc/ntp.conf
	echo "restrict 131.225.0.0 mask 255.255.0.0 nomodify" >> /etc/ntp.conf
	echo "broadcastclient" >> /etc/ntp.conf

fi

#
# This correctly configures /etc/ntp/step-tickers
#

if [ -s /etc/ntp/step-tickers ]; then
	if [ -f /etc/ntp/step-tickers.rpmsave ]; then
		mv /etc/ntp/step-tickers.rpmsave /etc/ntp/step-tickers.rpmsave.$$
	else
		cp /etc/ntp/step-tickers /etc/ntp/step-tickers.rpmsave
	fi
fi
echo "131.225.8.200 131.225.17.200" > /etc/ntp/step-tickers

#
# This correctly configures /etc/sysconfig/ntpd
#
	cat /etc/sysconfig/ntpd | sed "s:\"-u ntp:ntp -p /var/run/ntpd.pid\":\"-u ntp:ntp -p /var/run/ntpd.pid -A\":"  > /etc/sysconfig/ntpd.tmp
	mv -f /etc/sysconfig/ntpd.tmp /etc/sysconfig/ntpd

#
# This makes sure the daemon is added to the runlevels 3, 4, and 5
# and restarts the service

/sbin/chkconfig --add ntpd
/sbin/chkconfig --levels 345 ntpd on
/etc/init.d/ntpd restart > /dev/null 2>&1

#
# This makes it so that you don't get asked about ntp on the firstboot
# 
if [ -s /usr/share/firstboot/modules/date.py ]; then
	rm -f /usr/share/firstboot/modules/date.py*
fi

%triggerin -- firstboot
#
# This makes it so that you don't get asked about ntp on the firstboot
# 
if [ -s /usr/share/firstboot/modules/date.py ]; then
	rm -f /usr/share/firstboot/modules/date.py*
fi

